var dataGlobal = [];
var time, randomNumber, firstDateValue, firstValue;
var numberOfItemsOnGraph = 14;
var graphRefresh = 100;
var generateDataRate = graphRefresh;

const graphRefreshRate = document.querySelector('#graphRefreshRate');

const graphWidth = document.querySelector('#graphWidth');
// const output = document.querySelector('.graphWidth-output');
// output.textContent = graphWidth.value;

const outputGraphRefreshRate = document.querySelector('.graphRefreshRate-output');
outputGraphRefreshRate.textContent = graphWidth.value;

const outputGraphWidth = document.querySelector('.graphWidth-output');
outputGraphWidth.textContent = graphWidth.value;

graphRefreshRate.addEventListener('input', function () {
    window.localStorage.setItem("graphRefreshRate", graphRefreshRate.value);
    //console.log(window.localStorage.getItem("graphWidth"));
    location.reload();
});

graphWidth.addEventListener('input', function () {
    window.localStorage.setItem("graphWidth", graphWidth.value);
    //console.log(window.localStorage.getItem("graphWidth"));
    location.reload();
});


class GeneratedData {
    generateTemperature() {
        return this.temperature = Math.floor(Math.random() * (45 - 20 + 1) + 20);
    }
    generateHumidity() {
        return this.humidity = Math.floor(Math.random() * (90 - 40 + 1) + 40);
    }
    generatePressure() {
        return this.pressure = Math.floor(Math.random() * (1020 - 980 + 1) + 980);
    }
    generateUnixTimestamp() {
        return Date.now();
    }

    constructor(temperature, humidity, pressure) {
        this.unixTimeStamp = this.generateUnixTimestamp();
        this.temperature = temperature || this.generateTemperature();
        this.humidity = humidity || this.generateHumidity();
        this.pressure = pressure || this.generatePressure();
    }
}


function generateData() {
    var genData = new GeneratedData;
    time = genData.unixTimeStamp;
    randomNumber = genData.temperature;
    console.log(genData);
    if (dataGlobal.length < numberOfItemsOnGraph) {
        dataGlobal.push({
            x: time,
            y: randomNumber
        });
    }
    else if (dataGlobal.length == numberOfItemsOnGraph) {
        dataGlobal.shift(),
            dataGlobal.push({
                x: time,
                y: randomNumber
            });
    }
}


(function init() {
    var newGenInit = new GeneratedData;
    firstDateValue = newGenInit.unixTimeStamp;
    firstValue = newGenInit.temperature;
console.log(newGenInit);
    if ("graphWidth" in localStorage) {
        numberOfItemsOnGraph = window.localStorage.getItem("graphWidth");
    } 
    else {
        window.localStorage.setItem("graphWidth", numberOfItemsOnGraph);
    }

    if ("graphRefreshRate" in localStorage) {
        graphRefresh = window.localStorage.getItem("graphRefreshRate");
    } 
    else {
        window.localStorage.setItem("graphRefreshRate", graphRefresh);
    }

    // output.textContent = numberOfItemsOnGraph;
    outputGraphWidth.textContent = numberOfItemsOnGraph;
    outputGraphRefreshRate.textContent = graphRefresh;

    document.getElementById("graphRefreshRate").value = graphRefresh;
    generateDataRate = graphRefresh;
    document.getElementById("graphWidth").value = numberOfItemsOnGraph;


})();

setInterval(generateData, generateDataRate);

Highcharts.chart('container2', {
    chart: {
        type: 'spline',
        animation: Highcharts.svg, // don't animate in old IE
        marginRight: 10,
        events: {
            load: function () {

                // set up the updating of the chart each second
                var series = this.series[0];
                setInterval(function () {
                    var x = dataGlobal[dataGlobal.length - 1].x, // current time
                        y = dataGlobal[dataGlobal.length - 1].y;
                    series.addPoint([x, y], true, true);
                    //console.log(`Actual time: ${dataGlobal[dataGlobal.length-1].x} , actual value:   ${dataGlobal[dataGlobal.length-1].y}`);

                }, graphRefresh);
            }
        }
    },
    time: {
        useUTC: false
    },
    title: {
        text: 'Data refresh...'
    },
    accessibility: {
        announceNewData: {
            enabled: true,
            minAnnounceInterval: 15000,
            announcementFormatter: function (allSeries, newSeries, newPoint) {
                if (newPoint) {
                    return 'New point added. Value: ' + newPoint.y;
                }
                return false;
            }
        }
    },
    xAxis: {
        type: 'datetime',
        tickPixelInterval: 150
    },
    yAxis: {
        title: {
            text: 'Value'
        },
        plotLines: [{
            value: 0,
            width: 1,
            color: '#808080'
        }]
    },
    tooltip: {
        headerFormat: '<b>{series.name}</b><br/>',
        pointFormat: '{point.x:%Y-%m-%d %H:%M:%S}<br/>{point.y:.2f}'
    },
    legend: {
        enabled: false
    },
    exporting: {
        enabled: false
    },
    series: [{
        name: 'Generated data',
        data: (function () {
            // generate an array of random data
            var data = [],
                time = (new Date()).getTime(),
                i;
            for (var i = 0; i < numberOfItemsOnGraph; i++) {
                data.push({
                    x: firstDateValue,
                    y: firstValue
                });
            }
            return data;
        }())
    }]
});